/**
 * Ajoutez à la classe la méthode calculateGcd calculant et retournant le PGCD
 * de deux nombres entiers positifs (paramètres ou attributs). Le calcul se fait
 * par recherche linéaire, mais les algorithmes d'Euclide sont aussi acceptés.
 */
public class Problem1 {

    private int a;
    private int b;

    public Problem1(int pA, int pB) {
        a = pA;
        b = pB;
    }

    //version 'attributs'
    public int calculateGcd() {
        int gcd = 0;
        int min;
        if (a < b) {
            min = a;
            gcd = b; //pour le cas où a=0 -> gcd=b
        
        } else {
            min = b;
            gcd = a; //pour le cas où b=0 -> gcd=a
        }

        for (int i = 1; i <= min; i++) {
            if (a % i == 0 && b % i == 0) {
                gcd = i;
            }
        }
        return gcd;
    }

    //version 'paramètres'
    public int calculateGcd(int pA, int pB) {
        int gcd = 0;
        int min;
        if (pA < pB) {
            min = pA;
            gcd = pB;  //pour le cas où a=0 -> gcd=b
        } else {
            min = pB;
            gcd = pA;  //pour le cas où b=0 -> gcd=a
        }

        for (int i = 1; i <= min; i++) {
            if (pA % i == 0 && pB % i == 0) {
                gcd = i;
            }
        }
        return gcd;
    }

    //Algorithme d'Euclide par soustractions
    //voir aussi : http://de.wikipedia.org/wiki/Euklidischer_Algorithmus 
    public int calculateGcdEuclidSubtraction() {
        int gA = a;  //variables d'aide pour ne pas modifier les attributs
        int gB = b;

        if (gA == 0) {
            return gB;
        }

        while (gB != 0) {
            if (gA > gB) {
                gA = gA - gB;
            } else {
                gB = gB - gA;
            }
        }
        return gA;
    }

    //Algorithme d'Euclide par divisions
    //voir aussi :  http://de.wikipedia.org/wiki/Euklidischer_Algorithmus 
    public int calculateGcdEuclidDivision() {
        int gA = a;  //variables d'aide pour ne pas modifier les attributs
        int gB = b;
        int t = 0;

        while (gB != 0) {
            t  = gB;
            gB = gA % gB;
            gA = t;
        }

        return gA;
    }

    @Override
    public String toString() {
        return "GCD of " + a + " and " + b + " is: " + calculateGcd();
    }

}
