/**
 * Ajoutez à la classe la méthode isPrime qui indique si un nombre entier
 * (paramètre ou attribut) est un nombre premier ou non.
 */
public class Problem2 {

    private int number = 0;

    public Problem2(int pNumber) {
        number = pNumber;
    }

    //version 'attributs'
    public boolean isPrime() {
        int count = 0;

        for (int i = 1; i <= number; i++) {
            if (number % i == 0) {
                count++;
            }
        }

        return (count == 2);
    }

    
    //version 'paramètres'
    public boolean isPrime(int pNumber) {
        int count = 0;

        for (int i = 1; i <= pNumber; i++) {
            if (pNumber % i == 0) {
                count++;
            }
        }

        return (count == 2);
    }

    
    //version rapide - on s'arrête dès qu'on connaît la solution
    public boolean isPrime2() {
        int i = 2;
        while ((i < number) && (number % i != 0)) {
            i = i + 1;
        }
        return i == number;
    }


    /* version très rapide : 
     Idée: Tester s'il existe un diviseur >1 et <n
     Dans ce cas on peut s'arrêter de tester à sqrt(n), car
     s'il n'existe pas de diviseur <= sqrt(n), alors
     il ne peut pas exister de diviseur >sqrt(n) et <n ...
     */
    public boolean isPrime3() {
        int n = Math.abs(number);
        int i = 2;
        while (i <= Math.sqrt(n) && n % i != 0) {
            i++;
        }
        return n == 2 || n % i != 0 && n > 1;
		//Les conditions n==2 et n>1 sont nécessaires pour 
        //que la méthode retourne aussi un résultat correct 
        //pour n=1 (false)  et  n=2 (true)
    }

    
    @Override
    public String toString() {
        return "Number " + number + " is prime? " + isPrime2();
    }

}
