import java.util.ArrayList;

/**
 * La classe C possède un attribut du type ArrayList<K>. Ajoutez à la classe C la méthode find
 * qui recherche dans cette liste un élément qui correspond à un critère de recherche donné. La
 * méthode retourne la position de la première occurrence correspondant au critère de recherche.
 * Si aucun élément n'est trouvé, la valeur -1 est retournée.
 *
Variantes du problème : 
 *   • retourner la position de la dernière occurrence correspondant au critère de recherche (­1 si non trouvé).
 *   • retourner le premier objet de la liste correspondant au critère de recherche (null si non trouvé).
 *   • retourner le dernier objet de la liste correspondant au critère de recherche (null si non trouvé).
 * 
 * Exemple A : 
 * Soit une liste alPersons avec des éléments du type Person. 
 * Réalisez la méthode public int find(String pNeedle) qui retourne la position 
 * de la première personne qui porte le nom donné pNeedle. 
 * La méthode retourne -1 s’il n’existe pas de personne de ce nom dans la liste.
 */
public class Problem4A {

    private ArrayList<Person> alPersons = new ArrayList<>();

    public void addPerson(Person pPerson) {
        alPersons.add(pPerson);
    }

    //Trouver l'indice de la DERNIERE occurrence avec for	
    //version lente (parcourt toujours le tableau entier)
    public int findLast(String pNeedle) {
        int result = -1;  //l'indice à retourner comme résultat
        for (int i = 0; i < alPersons.size(); i++) {
            if (alPersons.get(i).getName().equals(pNeedle)) {
                result = i;
            }
        }
        return result;
    }

    
    //Version 1 : Trouver l'indice de la PREMIERE occurrence avec for A REBOURS
    //version lente (parcourt toujours le tableau entier)
    public int findFirst1(String pNeedle) {
        int result = -1;  //l'indice à retourner comme résultat
        for (int i = alPersons.size() - 1; i >= 0; i--) {
            if (alPersons.get(i).getName().equals(pNeedle)) {
                result = i;
            }
        }
        return result;
    }

    
    //Version 2 : Trouver l'indice de la PREMIERE occurrence avec for
    //version lente (parcourt toujours le tableau entier)
    //Attention au test sur result==-1 car il faut mémoriser la 1ère occurrence!
    public int findFirst2(String pNeedle) {
        int result = -1;  //l'indice à retourner comme résultat
        for (int i = 0; i < alPersons.size(); i++) {
            if (alPersons.get(i).getName().equals(pNeedle) && result == -1) {
                result = i;
            }
        }
        return result;
    }

    
    //Version 3 : Trouver l'indice de la PREMIERE occurrence avec while 
    //plus rapide (on s'arrête dès qu'on connaît la solution)
    public int findFirst3(String pNeedle) {
        int result = -1;  //l'indice à retourner comme résultat
        int i = 0;
        while (i < alPersons.size() && result == -1) {
            if (alPersons.get(i).getName().equals(pNeedle)) {
                result = i;
            }
            i++;
        }
        return result;
    }

    
    @Override
    public String toString() {
        return "Persons " + alPersons;
    }

}
