import java.awt.Point;
import java.util.ArrayList;

/**
 * La classe C possède un attribut du type ArrayList<K>. Ajoutez à la classe C la méthode find
 * qui recherche dans cette liste un élément qui correspond à un critère de recherche donné. La
 * méthode retourne le premier objet correspondant au critère de recherche.
 * Si aucun élément n'est trouvé, la valeur null est retournée.
 *
 * Variantes du problème : 
 *   • retourner la position de la première occurrence correspondant au critère de recherche (­1 si non trouvé).
 *   • retourner la position de la dernière occurrence correspondant au critère de recherche (­1 si non trouvé).
 *   • retourner le premier objet de la liste correspondant au critère de recherche (null si non trouvé).
 *   • retourner le dernier objet de la liste correspondant au critère de recherche (null si non trouvé).
 * 
 * Exemple B : 
 * Soit une liste alShapes avec des éléments du type Shape. 
 * Réalisez la méthode public Shape find(Point p) qui retourne 
 * la dernière figure de la liste pour laquelle contains(p) retourne true. 
 * La méthode find retourne null si contains retourne false pour tous les objets de la liste.
 */


public class Problem4B {
	
    private ArrayList<Shape> alShapes = new ArrayList<>();

    public void addShape(Shape pShape) {
        alShapes.add(pShape);
    }

    //Trouver le DERNIER objet qui correspond au critère avec for	
    //version lente (parcourt toujours le tableau entier)
    public Shape find(Point p) {
        Shape result = null;  //La figure à retourner comme résultat
        for (int i = 0; i < alShapes.size(); i++) { //continue jusqu'à la fin...
            Shape currentShape = alShapes.get(i);
            if (currentShape.contains(p)) {
                result = currentShape;
            }
        }
        return result;
    }
    

    //Trouver le DERNIER objet qui correspond au critère avec while 
    //plus rapide (on s'arrête dès qu'on connaît la solution)
    public Shape find1(Point p) {
        Shape result = null;  //La figure à retourner comme résultat
        int i = alShapes.size()-1; //commencer à la dernière figure
        while (i>=0 && result == null) { //arrêt si trouvé
            Shape currentShape = alShapes.get(i);
            if (currentShape.contains(p)) {
                result = currentShape;
            }
            i--;
        }
        return result;
    }

    @Override
    public String toString() {
    	  String result = "";
    	  for (int i = 0; i < alShapes.size(); i++)
    	  result += "["+i+"]  "+alShapes.get(i).toString()+"\n";
       return "alShapes : \n" + result;
    }
}