import java.util.ArrayList;

/**
 * La classe possède un attribut du type ArrayList<K>. Ajoutez à la classe la
 * méthode sort() qui trie cette liste à l'aide de l'algorithme de tri par
 * sélection directe suivant la valeur d'un attribut donné (Integer, Double,
 * String).
 *
 * Exemple : Tri d'une liste de personnes (classe Person) suivant leur nom.
 */
public class Problem5 {

    private ArrayList<Person> alPersons = new ArrayList<>();

    public void addPerson(Person pPerson) {
        alPersons.add(pPerson);
    }

    //Tri par sélection directe du minimum
    //critère de tri:  les noms des personnes
    // http://fr.wikipedia.org/wiki/Tri_par_sélection
    public void sort() {
        Person temp;
        Person minElement;
        Person currentMinElement;
        Person currentElementToTest;
        int currentMinimumPosition;

        // Parcourir avec destinationIndex la liste de 0 jusqu'à l'avant dernier élément
        //"destinationIndex", car c'est à cette position qu'on va placer le minimum
        for (int destinationIndex = 0; destinationIndex < alPersons.size() - 1; destinationIndex++) {
            //Rechercher la position du minimum derrière destinationIndex
            currentMinimumPosition = destinationIndex;
            for (int elementToTest = destinationIndex + 1; elementToTest < alPersons.size(); elementToTest++) {
                currentMinElement = alPersons.get(currentMinimumPosition);
                currentElementToTest = alPersons.get(elementToTest);
                if (currentMinElement.getName().compareTo(currentElementToTest.getName()) > 0) {
                    currentMinimumPosition = elementToTest;
                }
            }

            // Echanger les éléments aux positions destinationIndex et currentMinimumPosition si nécessaire
            if (currentMinimumPosition != destinationIndex) {
                temp = alPersons.get(destinationIndex);
                minElement = alPersons.get(currentMinimumPosition);

                alPersons.set(destinationIndex, minElement);
                alPersons.set(currentMinimumPosition, temp);
            }
        }
    }

    
    //Tri par sélection directe du minimum
    //critère de tri:  les noms des personnes (=> utiliser compareTo)
    // Exactement le même algorithme en notation plus compacte :
    public void sort2() {
        // Parcourir la liste avec i de 0 jusqu'à l'avant-dernier élément
        //i est l'indice où on va placer le minimum (qu'on recherche dans la 2e boucle)
        for (int i = 0; i < alPersons.size() - 1; i++) {
            //Rechercher la position du minimum derrière i
            int posMin = i;
            for (int j = i + 1; j < alPersons.size(); j++) {
                if (alPersons.get(posMin).getName().compareTo(alPersons.get(j).getName()) > 0) {
                    posMin = j;
                }
            }

            // Echanger les éléments aux positions i et posMin si nécessaire
            if (posMin != i) {
                Person temp = alPersons.get(i);
                alPersons.set(i, alPersons.get(posMin));
                alPersons.set(posMin, temp);
            }
        }
    }

    
    //Tri par sélection directe du minimum
    //critère de tri:  les années de naissance des personnes (=> utiliser > ou < )
    public void sort3() {
        // Parcourir avec i la liste de 0 jusqu'à l'avant-dernier élément
        for (int i = 0; i < alPersons.size() - 1; i++) {
            //Rechercher la position du minimum derrière i
            int posMin = i;
            for (int j = i + 1; j < alPersons.size(); j++) {
                if (alPersons.get(posMin).getBirthyear() > alPersons.get(j).getBirthyear()) {
                    posMin = j;
                }
            }

            // Echanger les éléments aux positions i et posMin si nécessaire
            if (posMin != i) {
                Person temp = alPersons.get(i);
                alPersons.set(i, alPersons.get(posMin));
                alPersons.set(posMin, temp);
            }
        }
    }

    
    @Override
    public String toString() {
        return "Persons " + alPersons;
    }

}
