import java.util.ArrayList;

/**
 * Calculez le minimum, le maximum, la somme et/ou la moyenne d'attributs
 * numériques d'objets contenus dans une liste.
 *
 * Exemple : Développez la méthode public int getBestMark() qui retourne la
 * meilleure note d'une liste de devoirs en classes.
 */
public class Problem6 {

    private ArrayList<Integer> alMarks = new ArrayList<>();

    public void addMark(int pMark) {
        alMarks.add(pMark);
    }

    
    //retourne -1 si la liste est vide
    public int getBestMark() {
        if (alMarks.size() > 0) {
            int max = alMarks.get(0);
            int current;

            for (int i = 1; i < alMarks.size(); i++) {
                current = alMarks.get(i);
                if (max < current) {
                    max = current;
                }
            }

            return max;
        } else {
            return -1;
        }
    }

    
    //retourne -1 si la liste est vide
    //variante sans variable 'current'
    public int getWorstMark() {
        if (alMarks.size() > 0) {
            int min = alMarks.get(0);
            for (int i = 1; i < alMarks.size(); i++) {
                if (min > alMarks.get(i)) {
                    min = alMarks.get(i);
                }
            }
            return min;
        } else {
            return -1;
        }
    }

    
    public int getSum() {
        int sum = 0;
        for (int i = 0; i < alMarks.size(); i++) {
            sum = sum + alMarks.get(i);
        }
        return sum;
    }

    
    public double getAverage() {
        //Attention: conversion de getSum() en 'double' 
        //pour effectuer une division de nombres décimaux!
        if (alMarks.size()==0) //si liste vide éviter division par zéro
           return 0;
        else 
           return (double) getSum() / alMarks.size();
    }

    
    @Override
    public String toString() {
        return "Marks " + alMarks + " min: " + getWorstMark() + " max: " + getBestMark() + " sum: " + getSum() + " average: " + getAverage();
    }

}
