import java.util.ArrayList;

/**
 * La classe C possède un attribut du type ArrayList<K>. Ajoutez à la classe C la méthode
 * removeAll qui supprime tous les éléments de la liste correspondant à un critère de recherche
 * donné.
 * 
 * Exemple: 
 * Soit une liste alPersons avec des éléments du type Person. 
 * Réalisez la méthode public void removeAll(int pBirthyear) qui supprime de la liste
 * toutes les personnes nées au cours de l’année pBirthyear ou avant cette année.
 */
public class Problem7A {

    private ArrayList<Person> alPersons = new ArrayList<>();

    public void addPerson(Person pPerson) {
        alPersons.add(pPerson);
    }

    //Version 1 : supprimer toutes les occurrences avec for A REBOURS
    //Lors de la suppression, la position des éléments et la longueur de la liste sont changées. 
    //En traversant la liste à rebours, ces modifications se font aux positions qu'on a déjà visités,
    //ainsi on évite des difficultés.
    public void removeAll(int pBirthyear) {
        for (int i = alPersons.size() - 1 ; i >= 0 ; i--) {
            if (alPersons.get(i).getBirthyear() <= pBirthyear) {
                alPersons.remove(i);
            }
        }
    }

    
    //Version 2 : supprimer toutes les occurrences avec while 
    //Dans ce cas il faut éviter d'avancer si on vient de supprimer un élément.
    public void removeAll1(int pBirthyear) {
        int i = 0;
        while (i < alPersons.size()) {
            if (alPersons.get(i).getBirthyear() <= pBirthyear) {
                alPersons.remove(i);
            } else {  //!!
            	i++;
            }
        }
    }

    
    @Override
    public String toString() {
        return "Persons " + alPersons;
    }
 
}
