import java.awt.Point;
import java.util.ArrayList;

/**
 * La classe C possède un attribut du type ArrayList<K>. Ajoutez à la classe C la méthode
 * removeAll qui supprime tous les éléments de la liste correspondant à un critère de recherche
 * donné.
 * 
 * Exemple:
 * Soit une liste alShapes avec des éléments du type Shape. 
 * Réalisez la méthode public void removeAll(Point p) qui supprime de la liste 
 * toutes les figures pour lesquelles contains(p) retourne true.
 */


public class Problem7B {
	
    private ArrayList<Shape> alShapes = new ArrayList<>();

    public void addShape(Shape pShape) {
        alShapes.add(pShape);
    }

    //Version 1 : supprimer toutes les occurrences avec for A REBOURS
    //Lors de la suppression, la position des éléments et la longueur de la liste sont changées. 
    //En traversant la liste à rebours, ces modifications se font aux positions qu'on a déjà visités,
    //ainsi on évite des difficultés.
    public void removeAll(Point p) {
        for (int i = alShapes.size() - 1 ; i >= 0 ; i--) {
            if (alShapes.get(i).contains(p)) {
                alShapes.remove(i);
            }
        }
    }

    
    //Version 2 : supprimer toutes les occurrences avec while 
    //Dans ce cas il faut éviter d'avancer si on vient de supprimer un élément.
    public void removeAll1(Point p) {
        int i = 0;
        while (i < alShapes.size()) {
            if (alShapes.get(i).contains(p)) {
                alShapes.remove(i);
            } else {  //!!
            	i++;
            }
        }
    }


    @Override
    public String toString() {
    	  String result = "";
    	  for (int i = 0; i < alShapes.size(); i++)
    	  result += "["+i+"]  "+alShapes.get(i).toString()+"\n";
       return "alShapes : \n" + result;
    }
}