import java.awt.Point;

/**
 * Une simple classe Shape (ici une figure rectangulaire) pour tester l'algorithme.
 */

public class Shape {
	
	private int x1, y1,  x2, y2;

	public Shape(int pX1, int pY1, int pX2, int pY2)	{
		x1 = pX1; 
		y1 = pY1;
		x2 = pX2;
		y2 = pY2;
	}

	public int getX1() {   return x1;	}
	public int getY1() {   return y1;	}
	public int getX2() {   return x2;	}
	public int getY2() {   return y2;	}

	public int getLeft()   {   return Math.min(x1,x2);	}
	public int getTop()    {   return Math.min(y1,y2);	}
	public int getWidth( ) {   return Math.abs(x1-x2);	}
	public int getHeight() {   return Math.abs(y1-y2);	}

     /**
      * retourne true <=> le point p se trouve à l'intérieur de la figure
      */     
     public boolean contains(Point p) {
     	return (getLeft() <= p.x  &&  p.x <= getLeft()+getWidth())  &&
     	       (getTop()  <= p.y  &&  p.y <= getTop() +getHeight());
     }

	public String toString() {
		return "Shape from P1("+x1+","+y1+") to P2("+x2+","+y2+")  left = "+getLeft()+"  top = "+getTop()+"  width = "+
		       getWidth()+"  height = "+getHeight();
	}
}